/* rexx program to convert PCBoard DIRxx files to html */

call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs

ARG Parm1

/* if Parm1 = '' then 
 signal syntax */

BackFile = Parm1

rc = Stream('dirlst.o','c','Query Exists')
if rc = '' then
	do
	say 'DIRLST.O file does not exist - please read doc file before using this program.'
	exit
end /* do */

if Backfile <> '' then
	do
	rc = Stream(Backfile,'c','Query Exists')
	if rc = '' then
		do
		say 'Background image file ('Backfile') does not exist.'
		exit
	end /* do */
end /* do */


Doutfile = 'dir.html'
rc = SysFileDelete(DOutfile)

rc = Lineout(DOutfile,'<!-- Generated by PCB2HTML - Version 1.0 -->')
rc = Lineout(DOutfile,'<!-- Copyright (c) 1999, Michael W. Cocke - cocke@catherders.com -->')
rc = Lineout(DOutfile,'<Html>')
rc = lineout(DOutfile,'<Head>')
rc = Lineout(DOutfile,'   <Meta Name="Generator" Content="PCB2HTML">')
rc = Lineout(DOutfile,'   <META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=iso-8859-1">')
rc = Lineout(DOutfile,'</Head>')

 if Backfile <> '' then
  rc = Lineout(DOutfile,'<Body Background="'backfile'" Link="#000000" Vlink="#000000" Alink="#000000">')


rc = Lineout(DOutfile,'<BaseFont Size=3>')
rc = Lineout(DOutfile,'<Br>')
rc = Lineout(DOutfile,'<Hr>')
rc = Lineout(DOutfile,'<Br>')

DLfile='dirlst.o'
do while lines(DLfile) = 1
	rc = stream(Infile,'c','close')
	rc = stream(Outfile,'c','close')

	Dline = Linein(DLfile)
	/* Say Dline */
	parse value Dline with AreaNumber '~'Infile'~'Dirpath'~'AreaDescription
	
 	say AreaNumber Infile Dirpath AreaDescription 

	outfile = Infile
	delim = pos('\',Outfile)
	do while delim >0
		parse value outfile with stuff'\'outfile
		delim = pos('\',Outfile)
	end /* do */

	Outfile = Outfile'.html'
	rc = Lineout(DOutfile, '<BR><A Href="'Outfile'">'AreaDescription'</A>') 

	BigDescr = ''

	rc = Stream(Infile,'c','Query Exists')
	if rc = '' then
		do
		say 'PCB config error - DIR.LST references non-existant DIR file.'
		say Infile
		exit
	end /* do */

	rc = SysFileDelete(Outfile)

	if right(Dirpath,1)='\' then
		do
		lendp = length(Dirpath)
		Dirpath = left(Dirpath,Lendp-1)
		end /* do */

	if substr(Dirpath,2,1) <>':' then
		do
		say ''
		say 'ERROR - please read the doc file before using this program!'
		say "See section titled 'Things you have to be willing to do in order for this to work,'"
		say 'notes on drive and path requirements in PCBoard dir setup.'
		say ''
		exit
		end /* do */
		else do
			lendp = length(Dirpath)
			Dirpath = right(Dirpath,Lendp-3)
		end /* if */


say 'DIR Infile:' Infile
say 'DIR Outfile:' Outfile
say 'DirPath: 'DirPath
/* pull dummy */
	


	rc = Lineout(Outfile,'<!-- Generated by PCB2HTML - Version 1.0 -->',1)
say rc
	rc = Lineout(Outfile,'<!-- Copyright (c) 1999, Michael W. Cocke - cocke@catherders.com -->')
	rc = Lineout(Outfile,'<Html>')
	rc = lineout(Outfile,'<Head>')
	rc = Lineout(Outfile,'   <Meta Name="Generator" Content="PCB2HTML">')
	rc = Lineout(Outfile,'   <META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=iso-8859-1">')
	rc = Lineout(Outfile,'</Head>')

	if Backfile <> '' then
	 rc = Lineout(Outfile,'<Body Background="'backfile'" Link="#000000" Vlink="#000000" Alink="#000000">')

	rc = Lineout(Outfile,'<BaseFont Size=3>')
	rc = Lineout(Outfile,'<Br>')
	rc = Lineout(Outfile,'<Hr>')

	/* Set up the title & page head sections with the area description */
	rc = Lineout(Outfile,'<Title>'AreaDescription'</Title>')
	rc = Lineout(Outfile,'<H1 Align=Center>')
	rc = Lineout(Outfile,'<Center><B>'AreaDescription'</B></Center>')
	rc = Lineout(Outfile,'</H1>')
	rc = Lineout(Outfile,'<Hr>')
	rc = Lineout(Outfile,'<Br>')
	DatLine = ''

	do while lines(Infile) = 1
		DatLine = Linein(Infile)
		
		if left(DatLine,1)='%' then  /* it's an include line - skip it */
			DatLine = ''

		if left(DatLine,1)='*' then  /* it's a header line - skip it */
			DatLine = ''


		if left(Datline,1) <> ' ' then /* it's a primary line */
			do
			if BigDescr <> '' then  /* Flush any previously built description */
				do
			/*	say Filename    FileSize    Filedate   */
				rc = Lineout(Outfile, '<BR>Filename: <A Href="'DirPath'\'Filename'">'Filename'</A>') 
				rc = Lineout(Outfile, '<BR>Filesize : 'Filesize)
				rc = Lineout(Outfile, '<BR>Filedate : 'Filedate'<BR>')
				rc = lineout(Outfile, BigDescr)
				rc = lineout(Outfile, '<BR><BR>')
				end /* do */
			Filename = strip(left(Datline,12),'both',' ')
			FileSize = substr(Datline,13,9)
			Filedate = substr(Datline,24,8)

	 		LenDat = length(Datline)
			Descr1 = right(Datline,LenDat-32) 
			Descr1 = strip(Descr1,'both',' ')

			BigDescr = Descr1
		end /* do */

	
		if left(DatLine,1)=' ' then /* it's a continutaion line */
			do

 			LenDat = length(Datline)
			DatLine = strip(Datline,'both',' ') 

			LenDat = length(Datline)
			DatLine = strip(Datline,'both','|') 
		
	 		LenDat = length(Datline)
			DatLine = strip(Datline,'both',' ') 

			BigDescr= BigDescr Datline

			end /* do */

		end /* do */

	rc = stream(Infile,'c','close')
	rc = stream(Outfile,'c','close')


		if BigDescr <> '' then  /* Flush any previously built description */
			do
/*			say Filename    FileSize    Filedate */
			rc = Lineout(Outfile, '<BR>Filename: <A Href="'DirPath'\'Filename'">'Filename'</A>') 
			rc = Lineout(Outfile, '<BR>Filesize : 'Filesize)
			rc = Lineout(Outfile, '<BR>Filedate : 'Filedate'<BR>')
			rc = lineout(Outfile, BigDescr)
			rc = lineout(Outfile, '<BR><BR>')
			end /* do */

		rc = Lineout(Outfile, '<BR><HR><BR>')
		rc = Lineout(Outfile, '<I>This page was last updated 'Date('W')', 'Date('N')'<BR>')
		rc = lineout(Outfile, 'and was automatically generated by PCB2HTML Version 1.0 - Copyright(c) 1999, Michael W. Cocke</I><BR>')
		rc = Lineout(Outfile, '<BR><HR><BR>')
	end
	rc = stream(Infile,'c','close')
	rc = stream(Outfile,'c','close')

	rc = Lineout(DOutfile, '<BR><HR><BR>')
	rc = Lineout(DOutfile, '<I>This page was last updated 'Date('W')', 'Date('N')'<BR>')
	rc = Lineout(DOutfile, 'and was automatically generated by PCB2HTML Version 1.0 - Copyright(c) 1999, Michael W. Cocke</I><BR>')
	rc = Lineout(DOutfile, '<BR><HR><BR>')

exit

Syntax:
call syscls
say ''
say ''
say 'PCB2HTML Version 1.0'
say 'Freeware, Copyright (C) 1999, Michael W. Cocke - cocke@catherders.com'
say ''
say 'Syntax:'
say 'PCB2HTML source destination dirpath {background file}'
say ''
say 'Source = Input file, PCBoard DIR format.'
say 'Destination = Output file, HTML format.'
say 'dirpath = drive and path to location of files described by the input DIR file.'
say 'background file = if specified, this jpg image file will be used as the'
say '   background for the HTML output file.'
say ''
say 'Notes:'
say '1) If the destination file exists, it will be overwritten.'
say '2) There is no validity checking for the dirpath.'
say '3) If you specify a background image file and it does not exist, '
say '   PCB2HTML will terminate.'
say ''
say 'Obviously, you can make changes to this program, but I would appreciate'
say 'it if you left my credit line at the bottom of the output screens.'
say ''
exit



